<!--
 * @Descripttion: (客户收货地址/tb_customer_address)
 * @version: (1.0)
 * @Author: (admin)
 * @Date: (2023-06-05)
 * @LastEditors: (admin)
 * @LastEditTime: (2023-06-05)
-->
<template>
  <div class="app-container">
    <el-row :gutter="24">
      <!-- 搜索框 queryParams.需要搜索的字段 -->
      <el-form :model="queryParams" label-position="left" style="margin:15px;" inline ref="queryForm" v-show="showSearch"
        @submit.prevent>
        <!-- <el-form-item label="所在地区">
          <el-cascader class="w100" :options="dataTreeList"
            :props="{ checkStrictly: true, value: 'regionId', label: 'regionName', emitPath: true }"
            placeholder="请选择所在地区" clearable v-model="queryParams.customerAddress" @change="handleCascaderChange">
            <template #default="{ data }">
              <span>{{ data.regionName }}</span>
            </template>
          </el-cascader>
        </el-form-item> -->
        <el-form-item label="收货人名称" prop="customerAddressName">
          <el-input v-model="queryParams.customerAddressName" placeholder="请输入收货人名称" clearable
            @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item label="收货电话" prop="customerAddressPhone">
          <el-input v-model="queryParams.customerAddressPhone" placeholder="请输入收货电话" clearable
            @keyup.enter="handleQuery" />
        </el-form-item>
        <el-form-item>
          <el-button icon="search" type="primary" @click="handleQuery">{{ $t('btn.search') }}</el-button>
          <el-button icon="refresh" @click="resetQuery">{{ $t('btn.reset') }}</el-button>
        </el-form-item>
      </el-form>
    </el-row>

    <!-- 工具按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" v-hasPermi="['business:customeraddress:addOrUpdate']" plain icon="plus"
          @click="AddDialogVisible = true">
          {{ $t('btn.add') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" :disabled="multiple" v-hasPermi="['business:customeraddress:delete']" plain icon="delete"
          @click="handleDelete">
          {{ $t('btn.delete') }}
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="download" @click="handleExport"
          v-hasPermi="['business:customeraddress:export']">
          {{ $t('btn.export') }}
        </el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="dataList" ref="tableRef" border highlight-current-row
      @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="50" align="center" />

      <el-table-column prop="customerName" label="客户" align="center" /> 
      <el-table-column prop="customerAddress" label="所在地区" align="center" />
      <el-table-column prop="customerAddressName" label="收货人名称" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerAddressPhone" label="收货电话" align="center" :show-overflow-tooltip="true" />
      <el-table-column prop="customerAddressDetailed" label="详细地址" align="center" :show-overflow-tooltip="true" />

      <el-table-column label="操作" width="350" fixed="right">
        <template #default="scope">
          <el-button type="primary" size="small" icon="edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['business:customeraddress:addOrUpdate']">编辑</el-button>
          <el-button type="danger" size="small" icon="delete" @click="handleDelete(scope.row)"
            v-hasPermi="['business:customeraddress:delete']">删除</el-button>
          <el-button size="small" icon="view" @click="handleDetail(scope.row)">查看</el-button>
        </template>
      </el-table-column>

    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
  </div>

  <!-- 添加 -->
  <AddDialog v-model="AddDialogVisible" :done="() => resetQuery()"></AddDialog>
  <!-- 编辑 -->
  <EditDialog v-model="EditDialogVisible" :data="EditDialogRow" :done="() => resetQuery()"></EditDialog>
  <!-- 详情 -->
  <DetailDialog v-model="DetailDialogVisible" :data="DetailDialogRow" :done="() => resetQuery()"></DetailDialog>
</template>
<script setup name="customeraddress">
import { ElMessageBox } from 'element-plus'
import modal from '@/plugins/modal.js'
import { exportCustomerAddress, customerAddressList, delCustomerAddress } from '@/api/business/Custom/CustomerAddresses/customerAddress.js'
import { regionTreeList } from '@/api/business/Custom/Regions/region.js';
import AddDialog from "./components/AddDialog.vue";
import EditDialog from "./components/EditDialog.vue";
import DetailDialog from "./components/DetailDialog.vue";

const AddDialogVisible = ref(false);
const EditDialogVisible = ref(false);
const EditDialogRow = ref({});
const DetailDialogVisible = ref(false);
const DetailDialogRow = ref({});

const { proxy } = getCurrentInstance()

// 选中categoryId数组数组
const ids = ref([])
// 非单选禁用
const single = ref(true)
// 非多个禁用
const multiple = ref(true)
// 显示搜索条件
const showSearch = ref(true)
// 数据列表
const dataList = ref([])
// 总记录数
const total = ref(0)
// 是否加载
const loading = ref(true)

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10
  },
})
const { queryParams } = toRefs(data)

// 业务参数
const dataTreeList = ref([])


// 业务方法

// 获取省市区数据
async function getTreeList() {
  regionTreeList().then((res) => {
    if (res.code == 200) {
      dataTreeList.value = res.data
    }
  })
}

// 处理所在地区，省市区传值
function handleCascaderChange(selectedValues) {
  console.log(selectedValues, '传参');
}


//基础方法

// 查询数据
function getList() {
  loading.value = true


  customerAddressList(queryParams.value).then((res) => {
    if (res.code == 200) {
      loading.value = false;
      dataList.value = res.data.result;
      total.value = res.data.totalNum;
    }
  });
}


// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.customerAddressId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 重置查询操作 */
function resetQuery() {
  proxy.resetForm('queryForm')
  handleQuery()
}
/** 搜索按钮操作 */
function handleQuery() {
  getList()
  // getTreeList()
}
/** 删除按钮操作 */
function handleDelete(row) {
  const Ids = row.customerAddressId || ids.value

  ElMessageBox.confirm("是否确认删除？", "系统提示", {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: "warning",
  })
    .then(function () {
      return delCustomerAddress(Ids)
    })
    .then(() => {
      handleQuery()
      modal.msgSuccess("删除成功")
    })
    .catch(() => { })
}

/** 导出按钮操作 */
function handleExport(row) {
  const Ids = row.customerAddressId || ids.value
  const name = ref("所有")

  if (Ids.length != 0) {
    const ids = Object.values(Ids).map(value => String(value));
    const str = ids.join(',');
    queryParams.value.ids = str
    name.value = "选中"
  }

  ElMessageBox.confirm('是否确认导出' + name.value + '数据?', '警告', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
  })
    .then(function () {
      return exportCustomerAddress(queryParams.value)
    })
    .then((response) => {
      proxy.download(response.data.path)
    })
}


// 修改
function handleUpdate(row) {
  EditDialogVisible.value = true
  EditDialogRow.value = row
}

// 详情
function handleDetail(row) {
  DetailDialogVisible.value = true
  DetailDialogRow.value = row
}

handleQuery()
</script>
